{              

   :  9 ,        ,
     1       12, 3, 6  9 , 
       0,1,2  3.    
      12 ,       -
   :
                                             
   1    2    3    4    5    6    7    8    9 
                                             
    ``   ,     90, 
   `` - ,      .   -
   ,        
    ,     .

 I :
	        : 1.     
     ; 2.         -
   K  (K>3)      K mod 4 , -
   ,           .
    9 ,       -
  3 ,   ,     ,
             -
    4   9 ,    4^9 = 262144 -
    ,         .
    ,     9    
      ,       .
       Try.

 II :
                 . 
         ,  -
   - ,   ..  ,   
        .     ,
         -  .

 III :
             [1..9].
  ,    1,2  4     1,
   1,2,3  5     2  ..   
       ,     (S1,
  S2,...S9) :
      S1  = ( S1' + t1 + t2 + t4           ) mod 4
      S2  = ( S2' + t1 + t2 + t3 + t5      ) mod 4
      S3  = ( S3' + t2 + t3 + t6           ) mod 4
      S4  = ( S4' + t1 + t4 + t5 + t7      ) mod 4
      S5  = ( S5' + t1 + t3 + t5 + t7 + t9 ) mod 4
      S6  = ( S6' + t3 + t5 + t6 + t9      ) mod 4
      S7  = ( S7' + t4 + t7 + t8           ) mod 4
      S8  = ( S8' + t5 + t7 + t8 + t9      ) mod 4
      S9  = ( S9' + t6 + t8 + t9           ) mod 4
   S1',S2',....,S9'       -
  ,  t1,t2,...,t9         
   1  9.     (S1=0,S2=0,...,S9=0),  
          9     4. 
       (     ).   -
          ,    
  -.       SolveEquation.

 IV :
            ,    -
     ,     .  
             -
   t1,t2,...,t9 ,    . (. SolveShort)

}
{$A+,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+}
{$M 16384,0,655360}
TYPE Clocks=  array[1..3,1..3] of byte;
CONST N = 9; {    }
      Cl: Clocks = (
  (2,1,3),
  (1,3,2),
  (3,2,1));

VAR Hodove: array[1..N] of integer;

Procedure PrintSolution;
Var I,J: byte;
Begin
  for I:= 1 to 9 do
    for J:= 1 to Hodove[I] do
      Write(I,' ');
  WriteLn;
End;

{-------------------------------- I  ----------------------------------}
Procedure Try(Br:byte); {   Br  0  3 }
  Procedure Rot(x,B:byte);
  Begin Cl[x,B]:=(Cl[x,B]+1) mod 4; End;
Var OldCl: Clocks;
    I: byte;
Begin
  if Br > 9 then
    begin
      if (Cl[1,1]=0) and (Cl[1,2]=0) and (Cl[1,3]=0) and
	 (Cl[2,1]=0) and (Cl[2,2]=0) and (Cl[2,3]=0) and
	 (Cl[3,1]=0) and (Cl[3,2]=0) and (Cl[3,3]=0) then
	PrintSolution; {   -     0}
      Exit;
    end;
  OldCl:=Cl; {     }
  for I:= 0 to 3 do
    begin
      Hodove[Br]:=I;
      if I>0 then
	case Br of
	  1: begin Rot(1,1); Rot(1,2); Rot(2,1); Rot(2,2); end;
	  2: begin Rot(1,1); Rot(2,1); Rot(3,1); end;
	  3: begin Rot(3,1); Rot(3,2); Rot(2,1); Rot(2,2); end;
	  4: begin Rot(1,1); Rot(1,2); Rot(1,3); end;
	  5: begin Rot(2,1); Rot(2,2); Rot(2,3); Rot(1,2); Rot(3,2); end;
	  6: begin Rot(3,1); Rot(3,2); Rot(3,3); end;
	  7: begin Rot(1,3); Rot(1,2); Rot(2,3); Rot(2,2); end;
	  8: begin Rot(1,3); Rot(2,3); Rot(3,3); end;
	  9: begin Rot(3,3); Rot(3,2); Rot(2,3); Rot(2,2); end;
	end;
      Try(Br+1);
    end;
  Cl:=OldCl; {     }
End;


{-------------------------------- III  --------------------------------}
Procedure SolveEquation;
Const N = 9;
Const A: array[1..N,1..N] of integer =( {  t1,t2,...,t9}
  ( 1,1,0,1,0,0,0,0,0 ),
  ( 1,1,1,0,1,0,0,0,0 ),
  ( 0,1,1,0,0,1,0,0,0 ),
  ( 1,0,0,1,1,0,1,0,0 ),
  ( 1,0,1,0,1,0,1,0,1 ),
  ( 0,0,1,0,1,1,0,0,1 ),
  ( 0,0,0,1,0,0,1,1,0 ),
  ( 0,0,0,0,1,0,1,1,1 ),
  ( 0,0,0,0,0,1,0,1,1 ));
Var B: array[1..N] of integer absolute Hodove;
    I,J,k,h: integer;
Begin
  for I:= 1 to 3 do
    for J:= 1 to 3 do
      B[I+(J-1)*3]:= 4-Cl[I,J];
  {       4   }
  { transform A into the unit matrix and b into a solution vector }
  for i := 1 to 9 do begin { process column i }
    { find pivot by bounded linear search for first 1 or 3 in column i }
    k := i ; h := 10 ;
    while k <> h do
      if A[k, i] in [1, 3] then h := k else inc(k) ;
    if k = 10 then begin
      writeln('Pivot not found in step ', i:1) ;
      halt
      end { if } ;
    { swap rows i and k }
    for j := i to 9 do begin
      h := A[i, j] ; A[i, j] := A[k, j] ; A[k, j] := h
      end { for j } ;
    h := b[i] ; b[i] := b[k] ; b[k] := h ;
    { normalize row i, yielding A[i, i] = 1 }
    h := A[i, i] ; { h * A[i, i] = 1 (mod 4) }
    for j := i to 9 do
      A[i, j] := (h * A[i, j]) mod 4 ;
    b[i] := (h * b[i]) mod 4 ;
    { sweep column i to zeroes in rows other than i }
    for k := 1 to 9 do begin { take care of row k }
      if k <> i then begin
	h := 3*A[k, i] ;
	for j := i to 9 do
	  A[k, j] := (A[k, j] + h*A[i, j]) mod 4 ;
	b[k] := (b[k] + h*b[i]) mod 4
	end { if }
      end { for j } ;
    end; { for i }
  PrintSolution;
End;


{--------------------------------- IV  --------------------------------}
Procedure SolveShort;
Var T: array[1..N] of integer absolute Hodove;
    S: array[1..N] of integer;
    I,J: integer;
Begin
  for I:= 1 to 3 do
    for J:= 1 to 3 do
      S[I+(J-1)*3]:= Cl[I,J];
  T[1] := (8+  S[1]+2*S[2]+  S[3]+2*S[4]+2*S[5]  -S[6]+  S[7]  -S[8]       ) mod 4;
  T[2] := (    S[1]+  S[2]+  S[3]+  S[4]+  S[5]+  S[6]+2*S[7]+       2*S[9]) mod 4;
  T[3] := (8+  S[1]+2*S[2]+  S[3]  -S[4]+2*S[5]+2*S[6]         -S[8]+  S[9]) mod 4;
  T[4] := (    S[1]+  S[2]+2*S[3]+  S[4]+  S[5]+         S[7]+  S[8]+2*S[9]) mod 4;
  T[5] := (4+  S[1]+2*S[2]+  S[3]+2*S[4]  -S[5]+2*S[6]+  S[7]+2*S[8]+  S[9]) mod 4;
  T[6] := (  2*S[1]+  S[2]+  S[3]+         S[5]+  S[6]+2*S[7]+  S[8]+  S[9]) mod 4;
  T[7] := (8+  S[1]  -S[2]+       2*S[4]+2*S[5]  -S[6]+  S[7]+2*S[8]+  S[9]) mod 4;
  T[8] := (  2*S[1]+       2*S[3]+  S[4]+  S[5]+  S[6]+  S[7]+  S[8]+  S[9]) mod 4;
  T[9] := (8         -S[2]+  S[3]  -S[4]+2*S[5]+2*S[6]+  S[7]+2*S[8]+  S[9]) mod 4;
  PrintSolution;
End;

BEGIN
  WriteLn;
  Try(1);        {I }
  SolveEquation; {III }
  SolveShort;    {IV }
END.